
// DxCliDlg.cpp : implementation file
//


#include "stdafx.h"
#include "DxClient.h"

#include "PmbWrap.h"

#include "DxClientDlg.h"

#include "PmBridge.h"

#include <sstream>

#include <xmllite.h> 



#define CHKHR(stmt)             do { hr = (stmt); if (FAILED(hr)) goto CleanUp; } while(0) 
#define HR(stmt)                do { hr = (stmt); goto CleanUp; } while(0) 
#define SAFE_RELEASE(I)         do { if (I){ I->Release(); } I = NULL; } while(0) 



HRESULT WriteAttributes(IXmlReader* pReader, WCHAR * pwszValueOut)
{
    const WCHAR* pwszPrefix;
    const WCHAR* pwszLocalName;
    const WCHAR* pwszValue;
    HRESULT hr = pReader->MoveToFirstAttribute();

    if (S_FALSE == hr)
        return hr;
    if (S_OK != hr)
    {
        wprintf(L"Error moving to first attribute, error is %08.8lx", hr);
        return hr;
    }
    else
    {
        while (TRUE)
        {
            if (!pReader->IsDefault())
            {
                UINT cwchPrefix;
                if (FAILED(hr = pReader->GetPrefix(&pwszPrefix, &cwchPrefix)))
                {
                    wprintf(L"Error getting prefix, error is %08.8lx", hr);
                    return hr;
                }
                if (FAILED(hr = pReader->GetLocalName(&pwszLocalName, NULL)))
                {
                    wprintf(L"Error getting local name, error is %08.8lx", hr);
                    return hr;
                }
                if (FAILED(hr = pReader->GetValue(&pwszValue, NULL)))
                {
                    wprintf(L"Error getting value, error is %08.8lx", hr);
                    return hr;
                }
                if (cwchPrefix > 0)
                    wprintf(L"Attr: %s:%s=\"%s\" \n", pwszPrefix, pwszLocalName, pwszValue);
                else {
                    wprintf(L"Attr: %s=\"%s\" \n", pwszLocalName, pwszValue);
                    wcscpy(pwszValueOut, pwszValue);
                }
            }

            if (S_OK != pReader->MoveToNextAttribute())
                break;
        }
    }
    return hr;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

    // Dialog Data
        //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAboutDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        // No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDxClientDlg dialog

CDxClientDlg::CDxClientDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CDxClientDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CDxClientDlg)
    m_strPatientID = _T("");
    m_strBirthDate = _T("");
    m_strDoctor = _T("");
    m_strFamilyName = _T("");
    m_strFirstName = _T("");
    m_strFileName = _T("");
    m_rbFormat = -1;
    m_bConvertTo8Bit = FALSE;
    m_bEnhance = FALSE;
    m_bOverview = FALSE;
    m_strLoginUser = _T("");
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    m_nImageCount = -1;
    m_nPatientStudies = -1;
    m_pArrStudyID = NULL;
    m_pArrStudyIDNames = NULL;
    m_nCaseCount = 0;
    strcpy(m_szGender, "");

    m_bAllCadCamCases = false;
    //  m_DiagnoseText = _T("");
    m_strDiagnose = _T("");

    // Call DxStart on init
    OnBnClickedButDxstart(false);
}


CDxClientDlg::~CDxClientDlg()
{
    // Close Dimaxis/Romexis
    // m_PmbWrap.ExitDx ();

    if (m_pArrStudyID != NULL) {
        delete[] m_pArrStudyID;
    }
    if (m_pArrStudyIDNames != NULL) {
        delete[] m_pArrStudyIDNames;
    }
}



void CDxClientDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CDxClientDlg)
    DDX_Control(pDX, IDC_COMBO_IMAGE_INDEX, m_comboImageIndex);
    DDX_Control(pDX, IDC_BTN_XRAY, m_buttonXRay);
    DDX_Text(pDX, IDC_EDIT_PATIENT_ID, m_strPatientID);
    DDV_MaxChars(pDX, m_strPatientID, 20);
    DDX_Text(pDX, IDC_EDIT_BIRTH_DATE, m_strBirthDate);
    DDV_MaxChars(pDX, m_strBirthDate, 10);
    DDX_Text(pDX, IDC_EDIT_DOCTOR, m_strDoctor);
    DDV_MaxChars(pDX, m_strDoctor, 32);
    DDX_Text(pDX, IDC_EDIT_FAMILY_NAME, m_strFamilyName);
    DDV_MaxChars(pDX, m_strFamilyName, 32);
    DDX_Text(pDX, IDC_EDIT_FIRST_NAME, m_strFirstName);
    DDV_MaxChars(pDX, m_strFirstName, 32);
    DDX_Text(pDX, IDC_EDIT_FILENAME, m_strFileName);
    DDV_MaxChars(pDX, m_strFileName, 255);
    DDX_Radio(pDX, IDC_RADIO_FORMAT_0, m_rbFormat);
    DDX_Check(pDX, IDC_CHECK_8BIT, m_bConvertTo8Bit);
    DDX_Check(pDX, IDC_CHECK_ENHANCE, m_bEnhance);
    DDX_Check(pDX, IDC_CHECK_OVERVIEW, m_bOverview);
    DDX_Text(pDX, IDC_EDIT_USER, m_strLoginUser);
    //}}AFX_DATA_MAP
    DDX_Control(pDX, IDC_COMBO_GENDER, m_cbGender);
    DDX_Check(pDX, IDC_CHECK_CADCAM, m_bAllCadCamCases);
    DDX_Control(pDX, IDC_COMBO_CASEID, m_comboCaseID);
    DDX_Control(pDX, IDC_COMBO_MODULE, m_comboModule);
    DDX_Text(pDX, IDC_EDITCTRL, m_strDiagnose);
    DDV_MaxChars(pDX, m_strDiagnose, 1950);
    DDX_Control(pDX, IDC_COMBO_STUDY_ID, m_comboStudyID);
    DDX_Control(pDX, IDC_CUR_EXT_ID, m_tf_cur_ext_id);
    DDX_Control(pDX, IDC_NEW_EXT_ID, m_tf_new_ext_id);
}

BEGIN_MESSAGE_MAP(CDxClientDlg, CDialog)
    //{{AFX_MSG_MAP(CDxClientDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_BTN_SELECT_PATIENT, OnBtnSelectPatient)
    ON_BN_CLICKED(IDC_BTN_INSERT_PATIENT, OnBtnInsertPatient)
    ON_BN_CLICKED(IDC_BTN_XRAY, OnBtnNormalizeWindow)
    ON_BN_CLICKED(IDC_BTN_DELETE_PATIENT, OnBtnDeletePatient)
    ON_BN_CLICKED(IDC_BTN_UPDATE_PATIENT, OnBtnUpdatePatient)
    ON_BN_CLICKED(IDC_BTN_INQUIRE_IMAGES, OnBtnInquireImages)
    ON_BN_CLICKED(IDC_BTN_GET_IMAGE, OnBtnGetImage)
    ON_BN_CLICKED(IDC_BTN_SELECT_IMAGE, OnBtnSelectImage)
    ON_BN_CLICKED(IDC_BTN_DESELECT_PATIENT, OnBtnDeselectPatient)
    ON_BN_CLICKED(IDC_BTN_SET_USER, OnBtnSetUser)
    ON_BN_CLICKED(IDC_BTN_RWND_FULL, OnBtnRwndFull)
    ON_BN_CLICKED(IDC_BTN_RWND_SMALL, OnBtnRwndSmall)
    ON_BN_CLICKED(IDC_BTN_WORKLIST, OnBtnWorklist)
    ON_BN_CLICKED(IDC_BTN_RWND_CLOSE, OnBtnRwndClose)
    ON_BN_CLICKED(IDC_BTN_CAPT_CAM, OnBtnCaptCam)
    ON_BN_CLICKED(IDC_BTN_CAPT_CEPH, OnBtnCaptCeph)
    ON_BN_CLICKED(IDC_BTN_CAPT_INTRA, OnBtnCaptIntra)
    ON_BN_CLICKED(IDC_BTN_CAPT_PAN, OnBtnCaptPan)
    ON_BN_CLICKED(IDC_BTN_XRAY_MAX, OnBtnMaximizeWindow)
    ON_BN_CLICKED(IDC_BTN_CAPT_CR_SCANNER, OnBtnCaptCRScanner)
    ON_BN_CLICKED(IDC_BTN_CAPT_TWAIN, OnBtnCaptTwain)
    ON_BN_CLICKED(IDC_BUTOPENIMAGE, OnButopenimage)
    ON_BN_CLICKED(IDC_BUT3D, OnBut3d)
    ON_BN_CLICKED(IDC_BUTEXIT, OnButexit)
    ON_BN_CLICKED(IDC_BUTGETIMAGEBYID, OnButgetimagebyid)
    //}}AFX_MSG_MAP
    ON_CBN_SELCHANGE(IDC_COMBO_GENDER, &CDxClientDlg::OnSelchangeComboGender)
    ON_BN_CLICKED(IDC_BUTCADCAM, &CDxClientDlg::OnBnClickedButcadcam)
    ON_BN_CLICKED(IDC_BUT_LAUNCHCASE, &CDxClientDlg::OnBnClickedButLaunchcase)
    ON_BN_CLICKED(IDC_BUTCLINIC, &CDxClientDlg::OnBnClickedButclinic)
    ON_BN_CLICKED(IDC_BUTGETCSTATUS, &CDxClientDlg::OnBnClickedButgetcstatus)
    ON_BN_CLICKED(IDC_BUTGETDIAGNOSE, &CDxClientDlg::OnBnClickedButgetdiagnose)
    ON_BN_CLICKED(IDC_BUTSETDIAGNOSE, &CDxClientDlg::OnBnClickedButsetdiagnose)
    ON_BN_CLICKED(IDC_BUTTMIN, &CDxClientDlg::OnBnClickedButtmin)
    ON_BN_CLICKED(IDC_BUTT_CLOSEIMGS, &CDxClientDlg::OnBnClickedButtCloseimgs)
    ON_BN_CLICKED(IDC_BUTT_GETSTUDYNUMS, &CDxClientDlg::OnBnClickedButtGetstudynums)
    ON_BN_CLICKED(IDC_BUTT_GETSTUDIES, &CDxClientDlg::OnBnClickedButtGetstudies)
    ON_BN_CLICKED(IDC_BUTT_GETSTUDY_INFO, &CDxClientDlg::OnBnClickedButtGetstudyInfo)
    ON_BN_CLICKED(IDC_BUT_START_STUDY_CAPTURE, &CDxClientDlg::OnBnClickedButStartStudyCapture)
    ON_BN_CLICKED(IDC_BUTT_GETSTID_NAMES, &CDxClientDlg::OnBnClickedButtGetstidNames)
    ON_BN_CLICKED(IDC_BUT_CHANGE_EXT_ID, &CDxClientDlg::OnBnClickedButChangeExtId)
    ON_BN_CLICKED(IDC_BUT_DXSTART, &CDxClientDlg::OnBnClickedButDxstart)
    ON_BN_CLICKED(IDC_BUT_QUERY_PATIENT, &CDxClientDlg::OnBnClickedButQueryPatient)
    ON_BN_CLICKED(IDC_BUTT_GET_PATIENT_ID, &CDxClientDlg::OnBnClickedButtGetPatientId)
    ON_BN_CLICKED(IDC_BUTT_ALWAYS_ON_TOP, &CDxClientDlg::OnBnClickedButtAlwaysOnTop)
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CDxClientDlg message handlers

BOOL CDxClientDlg::OnInitDialog()
{
    m_rbFormat = 0;

    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);			// Set big icon
    SetIcon(m_hIcon, FALSE);		// Set small icon

    m_buttonXRay.EnableWindow(FALSE); // Disable until patient selected


    // 2016/09
    //CString str;
    CString modulenums[] = { "PATIENTS", "FILES", "CLINIC", "RECORD", "2D-XRAY", "3D-MODULE", "EDU", "CADCAM", "ADMIN", "LOGIN", "SMILEDES" };

    /*
    for (int n=0; n < 11; n++ )
    {
        str.Format(L"%d", n);
        m_comboModule.AddString (str); // TODO: use strings similar to DxClientNET
    }
    */
    for (CString str : modulenums)
    {
        m_comboModule.AddString(str);
    }


    m_comboModule.SetCurSel(CMD_PATIENTS);

    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDxClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDxClientDlg::OnPaint()
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, (WPARAM)dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDxClientDlg::OnQueryDragIcon()
{
    return (HCURSOR)m_hIcon;
}


void CDxClientDlg::OnBtnSelectPatient()
{
    short ret = 0;

    UpdateData(TRUE);

    if (m_strPatientID == "")
    {
        MessageBox(L"Please Enter the Patient ID", NULL, MB_ICONEXCLAMATION);
        return;
    }


    short nDBStatus = m_PmbWrap.GetDBStatus();


    CString strMsg;
    if (nDBStatus != PMB_OK)
    {
        strMsg.Format(L"ERROR - Romexis is not connected to the database, DBStatus: %d",
            nDBStatus);
        MessageBox(strMsg);
        return;
    }

    USES_CONVERSION;
    short nImageCount;
    ret = m_PmbWrap.SelectPatient(W2A(m_strPatientID), &nImageCount);
    m_nImageCount = nImageCount;

    if (ret == PMB_OK) {
        m_buttonXRay.EnableWindow(TRUE);
        //#ifdef _DEBUG
        strMsg.Format(L"Return code: %d, Image Count: %d", ret, m_nImageCount);
        MessageBox(strMsg);
        //#endif
    }
    else {
        strMsg.Format(L"ERROR - Return code: %d, Image Count: %d", ret, m_nImageCount);
        MessageBox(strMsg);
    }

    // Set the image indices
    int n, nCount = m_comboImageIndex.GetCount();
    for (n = 0; n < nCount; n++)
        m_comboImageIndex.DeleteString(0);

    CString str;
    for (n = 0; n < m_nImageCount; n++)
    {
        str.Format(L"%d", n);
        m_comboImageIndex.AddString(str);
    }

    if (m_nImageCount > 0)
        m_comboImageIndex.SetCurSel(0);



}


void CDxClientDlg::OnBtnInsertPatient()
{
    UpdateData(TRUE);

    if (m_strPatientID == "" || m_strFamilyName == "")
    {
        MessageBox(L"Please Enter the Patient ID / Family Name", NULL, MB_ICONEXCLAMATION);
        return;
    }

    short ret = -1;
    USES_CONVERSION;
    if (m_strGender.IsEmpty()) {
        ret = m_PmbWrap.InsertPatientW(W2A(m_strPatientID), m_strFamilyName, m_strFirstName,
            W2A(m_strBirthDate), m_strDoctor);
    }
    else {
        ret = m_PmbWrap.InsertPatientW_Ex(W2A(m_strPatientID), m_strFamilyName, m_strFirstName,
            W2A(m_strBirthDate), m_strDoctor, W2A(m_strGender));
    }


    if (ret == PMB_OK) {
        m_buttonXRay.EnableWindow(TRUE);
    }
    else {
        CString strMsg;
        strMsg.Format(L"ERROR - Return code: %d", ret);
        MessageBox(strMsg);
    }
}



void CDxClientDlg::OnBtnNormalizeWindow()
{
    m_PmbWrap.SetDxWindowPlacement(SW_SHOWNORMAL);
}



void CDxClientDlg::OnBtnMaximizeWindow()
{
    m_PmbWrap.SetDxWindowPlacement(SW_SHOWMAXIMIZED);
}



void CDxClientDlg::OnBnClickedButtAlwaysOnTop()
{
    // Set on top, if boolean value is false
    short onTop = m_bToggleAlwaysOnTop ? 0 : 1;
    short retVal = DxAlwaysOnTop(onTop);

    std::wstringstream wss;
    if (retVal == PMB_OK) {
        m_bToggleAlwaysOnTop = !m_bToggleAlwaysOnTop;
        wss << "Success!";
    }
    else {
        wss << "Failure!";
    }

    wss << " Always on top mode set: " << m_bToggleAlwaysOnTop;

    MessageBox(wss.str().c_str());
}



void CDxClientDlg::OnBtnDeletePatient()
{
    UpdateData(TRUE);

    if (m_strPatientID == L"")
    {
        MessageBox(L"Please Enter the Patient ID", NULL, MB_ICONEXCLAMATION);
        return;
    }

    USES_CONVERSION;
    short ret = m_PmbWrap.DeletePatient(W2A(m_strPatientID));

    switch (ret)
    {
    case PMB_LOGIN_FAILED:
        MessageBox(L"Dimaxis/Romexis is not running or failed to login to the database",
            NULL, MB_ICONEXCLAMATION);
        break;

    case PMB_DELETE_NOT_ALLOWED:
        MessageBox(L"It is not allowed to delete the patient because the patient has images in the database",
            NULL, MB_ICONEXCLAMATION);
        break;

    case PMB_DELETE_FAILED:
        MessageBox(L"Failed to delete the patient", NULL, MB_ICONEXCLAMATION);
        break;

    case PMB_PATIENT_NOT_FOUND:
        MessageBox(L"The patient to be deleted was not found in the database",
            NULL, MB_ICONEXCLAMATION);
        break;

    case PMB_OK:
        m_strPatientID = "";
        m_strFamilyName = "";
        m_strFirstName = "";
        m_strBirthDate = "";
        m_strDoctor = "";
        UpdateData(FALSE);
        // MessageBox (L"The patient has been successfully deleted" );
        break;

    default:
        CString str;
        str.Format(L"ERROR - Unexpected return code: %d", ret);
        MessageBox(str, NULL, MB_ICONEXCLAMATION);
        break;
    }
}


void CDxClientDlg::OnBtnUpdatePatient()
{
    UpdateData(TRUE);

    if (m_strPatientID == "" || m_strFamilyName == "" || m_strFirstName == "")
    {
        MessageBox(L"Please Enter the Patient ID / Family Name / First Name", NULL, MB_ICONEXCLAMATION);
        return;
    }

    short ret = -1;
    USES_CONVERSION;
    if (m_strGender.IsEmpty()) {
        ret = m_PmbWrap.UpdatePatientW(W2A(m_strPatientID), m_strFamilyName, m_strFirstName,
            W2A(m_strBirthDate), m_strDoctor);
    }
    else {
        ret = m_PmbWrap.UpdatePatientW_Ex(W2A(m_strPatientID), m_strFamilyName, m_strFirstName,
            W2A(m_strBirthDate), m_strDoctor, W2A(m_strGender));
    }

    switch (ret)
    {
    case PMB_LOGIN_FAILED:
        MessageBox(L"ERROR - Romexis is not running or failed to login to the database",
            NULL, MB_ICONEXCLAMATION);
        break;

    case PMB_UPDATE_FAILED:
        MessageBox(L"ERROR - Failed to update the patient", NULL, MB_ICONEXCLAMATION);
        break;

    case PMB_PATIENT_NOT_FOUND:
        MessageBox(L"ERROR - The patient to be updated was not found in the database",
            NULL, MB_ICONEXCLAMATION);
        break;

    case PMB_OK:
        // MessageBox ( L"The patient has been successfully updated" );
        break;
    case PMB_PATIENT_ID_CONFLICT:
        MessageBox(L"ERROR - Given patient ID already exists. Give another ID");
        break;

    default:
        CString str;
        str.Format(L"ERROR - String text not given (yet) to return code: %d", ret);
        MessageBox(str, NULL, MB_ICONEXCLAMATION);
        break;
    }
}


void CDxClientDlg::OnBtnInquireImages() {

    int i;

    // MKH 2010/08/03
    for (i = 0; i < MAX_IMAGEIDS; i++) {
        m_nImageID[i] = -1;
    }

    short ret, nIndex;
    long  arrImageParam[DX_MAX_INDEX];
    short arrToothMask[33];  // 32 teeth, index=0 is not used, starting in index=1

    arrToothMask[0] = 0;
    //	short arrToothMask  [34] ;  

    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected");
        return;
    }
    else if (m_nImageCount == 0)
    {
        MessageBox(L"The selected patient don't have any images");
        return;
    }

    CString str = "", str2 = "";
    str.GetBuffer(2000);
    CString szMsg;

    nIndex = -1;
    for (i = 0; i < m_nImageCount; i++)
    {
        nIndex++;

        ret = m_PmbWrap.InquireImage(nIndex, arrImageParam, arrToothMask);
        if (ret != PMB_OK)
        {
            str.Format(L"ERROR - PmBridge Error %d", ret);
            MessageBox(str, NULL, MB_ICONHAND);
            return;
        }

        // MKH test
        // szMsg.Format("Index = %d",nIndex);
        // MessageBox (szMsg, NULL, MB_ICONHAND);

        str2.Format(
            L"Index %d ID %d Type %d Format %d  Size %d Date %d Time %d KV %d, mA %d Exp.Time %d Pixel Size %d Stype %d\n",
            nIndex,
            arrImageParam[DX_INDEX_IMAGE_ID],
            arrImageParam[DX_INDEX_IMAGE_TYPE],
            arrImageParam[DX_INDEX_FILE_FORMAT],
            arrImageParam[DX_INDEX_FILE_SIZE],
            arrImageParam[DX_INDEX_IMAGE_DATE],
            arrImageParam[DX_INDEX_IMAGE_TIME],
            arrImageParam[DX_INDEX_VOLTAGE],
            arrImageParam[DX_INDEX_CURRENT],
            arrImageParam[DX_INDEX_EXP_TIME],
            arrImageParam[DX_INDEX_PIXEL_SIZE],
            arrImageParam[DX_INDEX_IMAGE_SUBTYPE]);

        str += str2;

        // MKH 2013/03/01
        m_nImageID[nIndex] = (int)arrImageParam[DX_INDEX_IMAGE_ID];
        m_nImageType[nIndex] = (int)arrImageParam[DX_INDEX_IMAGE_TYPE];



    }

    MessageBox(str);
}



void CDxClientDlg::OnBtnGetImage()
{
    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected");
        return;
    }
    else if (m_nImageCount == 0)
    {
        MessageBox(L"The selected patient don't have any images");
        return;
    }

    UpdateData(TRUE);

    int nIndex = m_comboImageIndex.GetCurSel();
    short ret = -1;

    // Optionally check
    if (m_nImageID[nIndex] == 0) {
        MessageBox(L"Romexis image ID unspecified! Can not get image data", NULL, MB_ICONHAND);
        return;
    }

    if (m_strFileName.GetLength() == 0)
    {
        MessageBox(L"Please give the output file name");
        return;
    }

    m_strFileName.MakeUpper();

    char ext[10];
    ext[0] = '\0';
    char drive[10];
    drive[0] = '\0';
    USES_CONVERSION;

    _splitpath(W2A(m_strFileName), drive, NULL, NULL, ext);
    if (drive[0] == '\0') {
        MessageBox(L"Please give full path for the name");
        return;
    }
    if (strlen(ext) > 0) {
        MessageBox(L"Please give no extension for file name");
        return;
    }

    // MKH 2014/08/01
    CString strFullFileName = m_strFileName;
    // 2D image format can be set. All overview images are saved as 2D image!
    // 3D volume export format fixed  = DCM, IOScan surface image export format fixed = STL
    // TODO: ProScan surface format STL (export does not work yet!)
    if (m_bOverview || m_nImageType[nIndex] < DX_IT_CBCT || m_nImageType[nIndex] != DX_IT_BINARY)
    {
        if (m_rbFormat == DX_IF_TIFF)
        {
            strFullFileName += ".TIF";
        }
        else if (m_rbFormat == DX_IF_JPEG)
        {
            strFullFileName += ".JPG";
        }
        else if (m_rbFormat == DX_IF_BMP)
        {
            strFullFileName += ".BMP";
        }

    }

    if (m_bOverview)
        ret = m_PmbWrap.GetOverviewImage((short)nIndex, (short)m_rbFormat, W2A(strFullFileName));

    else
        ret = m_PmbWrap.GetImage((short)nIndex, (short)m_bConvertTo8Bit, (short)m_bEnhance,
        (short)m_rbFormat, W2A(strFullFileName));

    if (ret != PMB_OK)
    {
        CString str;
        str.Format(L"ERROR - PmBridge Error %d", ret);
        MessageBox(str, NULL, MB_ICONHAND);
        return;
    }

    MessageBox(L"DxGetImage was successful");
}


void CDxClientDlg::OnButgetimagebyid()
{
    // TODO: Add your control notification handler code here
    int nImageID = GetImageID();

    if (nImageID < 1)
    {
        MessageBox(L"Cannot get image by id ");
        return;
    }

    USES_CONVERSION;
    if (strlen(W2A(m_strFileName)) == 0)
    {
        MessageBox(L"Please give the output file name");
        return;
    }
    m_strFileName.MakeUpper();

    char ext[10];
    ext[0] = '\0';
    char drive[10];
    drive[0] = '\0';
    _splitpath(W2A(m_strFileName), drive, NULL, NULL, ext);
    if (m_rbFormat == DX_IF_TIFF && strcmp(ext, ".TIF"))
    {
        m_strFileName += ".TIF";
        UpdateData(FALSE);
    }
    else if (m_rbFormat == DX_IF_JPEG && strcmp(ext, ".JPG"))
    {
        m_strFileName += ".JPG";
        UpdateData(FALSE);
    }
    else if (m_rbFormat == DX_IF_BMP && strcmp(ext, ".BMP"))
    {
        m_strFileName += ".BMP";
        UpdateData(FALSE);
    }


    if (drive[0] == '\0') {
        MessageBox(L"Please give full path for the name");
        return;
    }


    FILE *fpTest = fopen(W2A(m_strFileName), "w");
    if (fpTest == NULL)
    {
        MessageBox(L"The file could not be created", NULL, MB_ICONHAND);
        return;
    }
    fclose(fpTest);

    int nIndex = m_comboImageIndex.GetCurSel();
    short ret = -1;

    if (m_nImageID[nIndex] == 0) {
        MessageBox(L"Romexis image type and ID unspecified! Can not get image data", NULL, MB_ICONHAND);
        return;
    }

    if (m_bOverview)
        // MKH 2010/08/05
        ret = m_PmbWrap.GetOverviewImageByID(nImageID, (short)m_rbFormat, W2A(m_strFileName));

    else
        // MKH 2010/08/05
        ret = m_PmbWrap.GetImageByID(nImageID, (short)m_bConvertTo8Bit, (short)m_bEnhance,
        (short)m_rbFormat, W2A(m_strFileName));

    if (ret != PMB_OK)
    {
        CString str;
        str.Format(L"ERROR - PmBridge Error %d", ret);
        MessageBox(str, NULL, MB_ICONHAND);
        return;
    }

    MessageBox(L"DxGetImagebyID was successful");
}

void CDxClientDlg::OnBtnSelectImage()
{


    UpdateData(TRUE);

    if (m_strPatientID == "")
    {
        MessageBox(L"Please Enter the Patient ID", NULL, MB_ICONEXCLAMATION);
        return;
    }
    CString strMsg;

    short nDBStatus = m_PmbWrap.GetDBStatus();



    if (nDBStatus != PMB_OK)
    {
        strMsg.Format(L"ERROR - Romexis is not connected to the database, DBStatus: %d",
            nDBStatus);
        MessageBox(strMsg);
        return;
    }


    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected");
        return;
    }

    //	else if ( m_nImageCount == 0 )
    //	{
    //		MessageBox (L"The selected patient don't have any images");
    //		return ;
    //	}


        // 
        // Open the SelectImage dialog
    m_PmbWrap.SelectImage();
}


void CDxClientDlg::OnBtnDeselectPatient()
{
    short nDBStatus = m_PmbWrap.DeselectPatient();

    if (nDBStatus != PMB_OK)
    {
        CString strMsg;
        strMsg.Format(L"ERROR - Could not close patient, Errno: %d",
            nDBStatus);
        MessageBox(strMsg);
    }
    /*
    else {
        CString strMsg ;
        strMsg.Format (L"OK, DBStatus: %d",
            nDBStatus );
        MessageBox (strMsg);
    }
    */
}



void CDxClientDlg::OnBtnSetUser()
{
    //	char *szUserName = "PmBridge" ;  

    //	char *szUserName = "hatakma" ;  
    //	char *szUserName = "Make"; 

    //	char *szUserName = "sysadm"; // 
    //	char *szUserName = "hatakmaddd" ; 
    UpdateData(TRUE);

    short nDBStatus = m_PmbWrap.GetDBStatus();

    CString strMsg;

    if (nDBStatus != PMB_OK)
    {
        strMsg.Format(L"ERROR - Romexis is not connected to the database, Errno: %d",
            nDBStatus);
        MessageBox(strMsg);
        return;
    }

    unsigned short nAccessLevel =  // Full control..
        DX_ACL_ACQUIRE_IMAGE + DX_ACL_DELETE_IMAGE + DX_ACL_ADMINISTRATION;

    USES_CONVERSION;
    short nRet = m_PmbWrap.SetUser(W2A(m_strLoginUser), nAccessLevel);
    if (nRet != PMB_OK) {
        CString msg;
        msg.Format(L"ERROR - Could not set user. Error : %d", nRet);
        MessageBox(msg);
    }

    // TEST for Entteri company 2018/05/15 - Indirect calls - Works OK
    // OnBtnSelectPatient();
    // OnBnClickedButclinic();

    // TEST for Entteri company 2018/05/15 - Direct calls - Works OK
    short ret = m_PmbWrap.SelectPatient(W2A(L"12345"), &m_nImageCount);
    ret = m_PmbWrap.SelectRmxModule(4);


}


void CDxClientDlg::OnBtnRwndSmall()
{
    if (m_PmbWrap.SetImageRetrievalWindowSize(DX_RWND_SIZE_SMALL) == PMB_OK)
    {
        /*
                short nSize ;
                long nLeft, nRight, nTop, nBottom ;

                if ( m_PmbWrap.GetImageRetrievalWindowSize ( &nSize,
                 &nLeft, &nRight, &nTop, &nBottom ) == PMB_OK )
                {
                    CString str ;
                    str.Format ("Size %d  L %d R %d      T %d B %d", nSize, nLeft, nRight, nTop, nBottom );
                    MessageBox (str, "Window Size");
                }
        */
    }
}

void CDxClientDlg::OnBtnRwndFull()
{
    if (m_PmbWrap.SetImageRetrievalWindowSize(DX_RWND_SIZE_FULL) == PMB_OK)
    {
        /*
                short nSize ;
                long nLeft, nRight, nTop, nBottom ;

                if ( m_PmbWrap.GetImageRetrievalWindowSize ( &nSize,
                 &nLeft, &nRight, &nTop, &nBottom ) == PMB_OK )
                {
                    CString str ;
                    str.Format ("Size %d  L %d R %d      T %d B %d", nSize, nLeft, nRight, nTop, nBottom );
                    MessageBox (str, "Window Size");
                }
        */
    }
}

void CDxClientDlg::OnBtnRwndClose()
{
    m_PmbWrap.SetImageRetrievalWindowSize(DX_RWND_CLOSE);
}



void CDxClientDlg::OnBtnWorklist() {

    UpdateData();

    if (m_strPatientID == "")
    {
        MessageBox(L"Please Enter the Patient ID", NULL, MB_ICONEXCLAMATION);
        return;
    }

    char *pszStartDate = "20021128";
    char *pszStartTime = "0930";

    //	char *pszModality  = "IO"   ;
    char *pszModality = "CR";

    char *pszStepID = "123";
    char *pszStepDesc = "...";

    char *pszProcedureID = "456";
    char *pszProcedureDesc = "proc.desc";

    char *pszStudyInstanceUID = "1.124.4322.930.2002128";
    char *pszAccessionNumber = "1234567";

    short arrToothMask[34];
    memset(arrToothMask, 0, sizeof(arrToothMask));

    arrToothMask[1] = '1'; // Tooth 11

    USES_CONVERSION;
    m_PmbWrap.SetWorklistEntry(W2A(m_strPatientID), pszStartDate, pszStartTime,
        pszModality, pszStepID, pszStepDesc, pszProcedureID, pszProcedureDesc,
        pszStudyInstanceUID, pszAccessionNumber, arrToothMask);
}




void CDxClientDlg::OnBtnCaptCam()
{
    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected", NULL, MB_ICONEXCLAMATION);
        return;
    }

    m_PmbWrap.CaptureImage(DX_IT_INTRACAM);
}


void CDxClientDlg::OnBtnCaptCeph()
{
    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected", NULL, MB_ICONEXCLAMATION);
        return;
    }

    short nRet = m_PmbWrap.CaptureImage(DX_IT_CEPH);
    CString msg;
    msg.Format(L"Return code : %d", nRet);
    MessageBox(msg);
}


void CDxClientDlg::OnBtnCaptIntra()
{
    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected", NULL, MB_ICONEXCLAMATION);
        return;
    }

    short nRet = m_PmbWrap.CaptureImage(DX_IT_INTRA);
    CString msg;
    msg.Format(L"Return code : %d", nRet);
    MessageBox(msg);

    //    m_PmbWrap.CaptureImageIntra(1,0);

}


void CDxClientDlg::OnBtnCaptPan()
{
    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected", NULL, MB_ICONEXCLAMATION);
        return;
    }

    short nRet = m_PmbWrap.CaptureImage(DX_IT_PAN);
    CString msg;
    msg.Format(L"Return code : %d", nRet);
    MessageBox(msg);
}


void CDxClientDlg::OnBtnCaptCRScanner()
{
    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected", NULL, MB_ICONEXCLAMATION);
        return;
    }

    m_PmbWrap.CaptureImage(DX_IT_CR_SCANNER);
}

void CDxClientDlg::OnBtnCaptTwain()
{
    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected", NULL, MB_ICONEXCLAMATION);
        return;
    }

    short ret = m_PmbWrap.CaptureImage(DX_IT_TWAIN);

    if (ret != PMB_OK)
    {
        CString str;
        str.Format(L"ERROR -  PmBridge Error %d", ret);
        MessageBox(str, NULL, MB_ICONHAND);
    }
    // else {
    //	MessageBox (L"OK", NULL, MB_ICONHAND);
    // }
}



// MKH 2010/06/04
void CDxClientDlg::OnButopenimage()
{

    int nImageID = GetImageID();

    short ret = -1;

    int nIndex = m_comboImageIndex.GetCurSel();
    //	ret = m_PmbWrap.OpenImage ( (short)nIndex, (short) 0 );
    ret = m_PmbWrap.OpenImage((short)nIndex, nImageID); // MKH 2010/08/03

    if (ret != PMB_OK)
    {
        CString str;
        str.Format(L"ERROR - PmBridge Error %d", ret);
        MessageBox(str, NULL, MB_ICONHAND);
        return;
    }

    // MessageBox (L"DxOpenImage was successful");

}

void CDxClientDlg::OnBut3d()
{
    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected", NULL, MB_ICONEXCLAMATION);
        return;
    }

    short nRet = m_PmbWrap.CaptureImage(DX_IT_CBCT);
    CString msg;
    msg.Format(L"Return code : %d", nRet);
    MessageBox(msg);
}

void CDxClientDlg::OnButexit()
{
    // TODO: Add your control notification handler code here
    short nRet = m_PmbWrap.ExitDx();
    CString msg;
    msg.Format(L"Return code : %d", nRet);
    MessageBox(msg);
}




void CDxClientDlg::OnSelchangeComboGender()
{
    // TODO: Add your control notification handler code here
    int nIndex = m_cbGender.GetCurSel();
    if (nIndex != CB_ERR) {
        if (nIndex == 0) {
            strcpy(m_szGender, "");
            m_strGender = "";
        }
        else {
            // CString strGender;
            m_cbGender.GetLBText(nIndex, m_strGender);
            USES_CONVERSION;
            strcpy(m_szGender, T2A(m_strGender.GetBuffer()));

        }
    }
}


void CDxClientDlg::OnBnClickedButcadcam()
{
    // TODO: Add your control notification handler code here

    int nImageID = GetImageID();

    if (!m_bAllCadCamCases) {

        if (nImageID < 1) {
            MessageBox(L"Romexis cadcam (image) ID unspecified! Can not get cad/cam case data", NULL, MB_ICONHAND);
            return;
        }
    }

    if (m_strFileName.GetLength() == 0)
    {
        MessageBox(L"Please give the output file name");
        return;
    }


    char ext[10];
    ext[0] = '\0';
    char drive[10];
    drive[0] = '\0';
    USES_CONVERSION;

    _splitpath(W2A(m_strFileName), drive, NULL, NULL, ext);
    if (drive[0] == '\0') {
        MessageBox(L"Please give full path for the name");
        return;
    }
    if (strlen(ext) < 1) {
        MessageBox(L"Please give a full path of file name with 'xml' suffix");
        return;
    }
    /*
    else {
        CString cext= A2W(ext);
        if (cext.MakeUpper().Compare( L"XML" ) == -1) {
            MessageBox (L"Please give file name with 'xml' or 'XML' suffix");
            return ;
        }
    }
    */

    short ret = m_PmbWrap.InquireCadCamCase(nImageID, W2A(m_strFileName));

    if (ret != PMB_OK)
    {
        CString str;
        str.Format(L"ERROR - PmBridge Error %d", ret);
        MessageBox(str, NULL, MB_ICONHAND);
        return;
    }

    // Parse XML file
    if (m_strFileName.GetLength() == 0)
    {
        MessageBox(L"Please give first the output file name and also inquire XML info ");
        return;
    }
    GetCadCamIDNums(W2A(m_strFileName));
    CString str;
    str.Format(L"CadCam cases found %d in XML file", m_nCaseCount);
    MessageBox(str, NULL, MB_ICONHAND);
    // set first index
    m_comboCaseID.SetCurSel(0);

    // MessageBox (L"DxInquireCadCamCase was successful");

}

void CDxClientDlg::GetCadCamIDNums(const char *pFileName) {
    HRESULT hr = S_OK;
    IStream *pFileStream = NULL;
    IXmlReader *pReader = NULL;
    XmlNodeType nodeType;
    const WCHAR* pwszPrefix;
    const WCHAR* pwszLocalName;
    const WCHAR* pwszValue;
    UINT cwchPrefix;

    //Open read-only input stream 
    USES_CONVERSION;
    if (FAILED(hr = SHCreateStreamOnFile(A2W(pFileName), STGM_READ, &pFileStream)))
    {
        wprintf(L"Error creating file reader, error is %08.8lx", hr);
        MessageBox(L"Error creating file reader", NULL, MB_ICONHAND);
        HR(hr);
        return;
    }

    if (FAILED(hr = CreateXmlReader(__uuidof(IXmlReader), (void**)&pReader, NULL)))
    {
        wprintf(L"Error creating xml reader, error is %08.8lx", hr);
        MessageBox(L"Error creating file reader", NULL, MB_ICONHAND);
        HR(hr);
    }

    if (FAILED(hr = pReader->SetProperty(XmlReaderProperty_DtdProcessing, DtdProcessing_Prohibit)))
    {
        wprintf(L"Error setting XmlReaderProperty_DtdProcessing, error is %08.8lx", hr);
        MessageBox(L"Error setting XmlReaderProperty_DtdProcessing", NULL, MB_ICONHAND);
        HR(hr);
    }

    if (FAILED(hr = pReader->SetInput(pFileStream)))
    {
        wprintf(L"Error setting input for reader, error is %08.8lx", hr);
        MessageBox(L"Error setting input for reader", NULL, MB_ICONHAND);
        HR(hr);
    }

    WCHAR wszValue[100];
    bool bReadNext = false;
    //read until there are no more nodes 
    while (S_OK == (hr = pReader->Read(&nodeType)))
    {
        switch (nodeType)
        {
        case XmlNodeType_XmlDeclaration:
            wprintf(L"XmlDeclaration\n");
            if (FAILED(hr = WriteAttributes(pReader, wszValue)))
            {
                wprintf(L"Error writing attributes, error is %08.8lx", hr);
                HR(hr);
            }
            break;
        case XmlNodeType_Element:
            if (FAILED(hr = pReader->GetPrefix(&pwszPrefix, &cwchPrefix)))
            {
                wprintf(L"Error getting prefix, error is %08.8lx", hr);
                HR(hr);
            }
            if (FAILED(hr = pReader->GetLocalName(&pwszLocalName, NULL)))
            {
                wprintf(L"Error getting local name, error is %08.8lx", hr);
                HR(hr);
            }
            if (cwchPrefix > 0)
                wprintf(L"Element: %s:%s\n", pwszPrefix, pwszLocalName);
            else
                wprintf(L"Element: %s\n", pwszLocalName);

            if (wcscmp(pwszLocalName, L"Case") == 0) {
                bReadNext = true;
            }
            if (!bReadNext) {
                // todo: DO WE HAVE TO READ all attributes? YES

                if (FAILED(hr = WriteAttributes(pReader, wszValue)))
                {
                    wprintf(L"Error writing attributes, error is %08.8lx", hr);
                    HR(hr);
                }
                break;
            }

            if (wcscmp(pwszLocalName, L"ImageId") == 0) {
                // read Attribute value

                bReadNext = false;
                // TODO: actually get attribute value
                if (FAILED(hr = WriteAttributes(pReader, wszValue)))
                {
                    wprintf(L"Error writing attributes, error is %08.8lx", hr);
                    HR(hr);
                }
                else {
                    // parse ID
                    CString msg;
                    msg.Format(L"Cadcam Case ID (=Image number):%s", wszValue);
                    MessageBox(msg, L"Info", MB_ICONHAND);
                    m_comboCaseID.AddString(wszValue);
                    m_nCaseCount++;
                }
            }

            if (pReader->IsEmptyElement())
                wprintf(L" (empty)");
            break;
        case XmlNodeType_EndElement:
            if (FAILED(hr = pReader->GetPrefix(&pwszPrefix, &cwchPrefix)))
            {
                wprintf(L"Error getting prefix, error is %08.8lx", hr);
                HR(hr);
            }
            if (FAILED(hr = pReader->GetLocalName(&pwszLocalName, NULL)))
            {
                wprintf(L"Error getting local name, error is %08.8lx", hr);
                HR(hr);
            }
            if (cwchPrefix > 0)
                wprintf(L"End Element: %s:%s\n", pwszPrefix, pwszLocalName);
            else
                wprintf(L"End Element: %s\n", pwszLocalName);
            break;
        case XmlNodeType_Text:
        case XmlNodeType_Whitespace:
            if (FAILED(hr = pReader->GetValue(&pwszValue, NULL)))
            {
                wprintf(L"Error getting value, error is %08.8lx", hr);
                HR(hr);
            }
            wprintf(L"Text: >%s<\n", pwszValue);
            break;
        case XmlNodeType_CDATA:
            if (FAILED(hr = pReader->GetValue(&pwszValue, NULL)))
            {
                wprintf(L"Error getting value, error is %08.8lx", hr);
                HR(hr);
            }
            wprintf(L"CDATA: %s\n", pwszValue);
            break;
        case XmlNodeType_ProcessingInstruction:
            if (FAILED(hr = pReader->GetLocalName(&pwszLocalName, NULL)))
            {
                wprintf(L"Error getting name, error is %08.8lx", hr);
                HR(hr);
            }
            if (FAILED(hr = pReader->GetValue(&pwszValue, NULL)))
            {
                wprintf(L"Error getting value, error is %08.8lx", hr);
                HR(hr);
            }
            wprintf(L"Processing Instruction name:%s value:%s\n", pwszLocalName, pwszValue);
            break;
        case XmlNodeType_Comment:
            if (FAILED(hr = pReader->GetValue(&pwszValue, NULL)))
            {
                wprintf(L"Error getting value, error is %08.8lx", hr);
                HR(hr);
            }
            wprintf(L"Comment: %s\n", pwszValue);
            break;
        case XmlNodeType_DocumentType:
            wprintf(L"DOCTYPE is not printed\n");
            break;
        }
    }

CleanUp:
    SAFE_RELEASE(pFileStream);
    SAFE_RELEASE(pReader);
}

void CDxClientDlg::OnBnClickedButLaunchcase()
{
    /*
        // TEST
        UpdateData(TRUE);
        if (m_strFileName.GetLength() == 0 )
        {
            MessageBox (L"Please give first the output file name and also inquire XML info ");
            return ;
        }

         USES_CONVERSION;
         GetCadCamIDNums(W2A(m_strFileName));


        // set first index
        m_comboCaseID.SetCurSel (0);
    */

    // TODO: Add your control notification handler code here
    UpdateData(TRUE);

    CString strID;
    m_comboCaseID.GetWindowTextW(strID);

    CString str;
    str.Format(L"open CadCam case: %s ", strID);
    MessageBox(str, NULL, MB_ICONHAND);
    short ret = -1;
    int nCaseID = _wtoi(strID);

    ret = m_PmbWrap.OpenCadCamCase(nCaseID);
    if (ret != PMB_OK)
    {

        str.Format(L"ERROR - PmBridge Error %d", ret);
        MessageBox(str, NULL, MB_ICONHAND);
        return;
    }

    // MessageBox (L"DxOpenCadCamCase was successful");
}




void CDxClientDlg::OnBnClickedButclinic()
{

    int nModule = m_comboModule.GetCurSel();


    // int nModule=CMD_CLINIC;
    short ret = m_PmbWrap.SelectRmxModule(nModule);

    if (ret != PMB_OK)
    {
        CString str;
        str.Format(L"ERROR - PmBridge Error %d", ret);
        MessageBox(str, NULL, MB_ICONHAND);
        return;
    }

    // MessageBox (L"DxSelectRmxModule was successful");	
}


// Get clinic status
void CDxClientDlg::OnBnClickedButgetcstatus()
{
    UpdateData(TRUE);

    // Result to a file
    /*
    if (m_strFileName.GetLength() == 0 )
    {
        MessageBox (L"Please give the output file name");
        return ;
    }


    char ext[10] ;
    ext [0] = '\0';
    char drive[10];
    drive[0]='\0';
    USES_CONVERSION;

    _splitpath( W2A(m_strFileName), drive, NULL, NULL, ext );
    if (drive[0]=='\0') {
        MessageBox (L"Please give full path for the name");
        return ;
    }
    if (strlen(ext) < 1) {
        MessageBox (L"Please give a full path of file name with 'xml' suffix");
        return ;
    }

    // to a file
    short ret = m_PmbWrap.GetClinicStatus(W2A(m_strFileName));
*/
// Entteri test 2018/06/04
    if (m_PmbWrap.m_hPmbDLL != NULL) {
        m_PmbWrap.FreePMLibrary();

        m_PmbWrap.LoadPMLibrary();
    }
    else {
        m_PmbWrap.LoadPMLibrary();
    }

    // Result to a string (XML format)
    WCHAR wszClinicStatus[20400];
    short ret = m_PmbWrap.GetClinicStatusStr(wszClinicStatus);

    if (ret != PMB_OK)
    {
        CString str;
        str.Format(L"ERROR - PmBridge Error %d", ret);
        MessageBox(str, NULL, MB_ICONHAND);
        return;
    }
    else {
        // MessageBox (L"DxGetClinicStatus was successful");
        MessageBox(wszClinicStatus);
    }

    if (m_PmbWrap.m_hPmbDLL != NULL) {
        m_PmbWrap.FreePMLibrary();
    }
}

int CDxClientDlg::GetImageID() {
    int nImageID = 0;

    if (m_nImageCount < 0)
    {
        MessageBox(L"Patient has not been selected");
        return nImageID;
    }
    else if (m_nImageCount == 0)
    {
        MessageBox(L"The selected patient does have any images");
        return nImageID;
    }
    UpdateData(TRUE);

    int nIndex = m_comboImageIndex.GetCurSel();

    nImageID = (int)m_nImageID[nIndex];

    return nImageID;
}

void CDxClientDlg::OnBnClickedButgetdiagnose()
{

    int nImageID = GetImageID();

    if (nImageID < 1)
    {
        MessageBox(L"Cannot get image diagnose ");
        return;
    }

    /*
        char ext[10] ;
        ext [0] = '\0';
        char drive[10];
        drive[0]='\0';
        USES_CONVERSION;

        _splitpath( W2A(m_strFileName), drive, NULL, NULL, ext );
        if (drive[0]=='\0') {
            MessageBox (L"Please give full path for the name");
            return ;
        }
        if (strlen(ext) < 1) {
            MessageBox (L"Please give a full path of file name with 'xml' suffix");
            return ;
        }
        short ret = m_PmbWrap.GetImageDiagnose(nImageID,W2A(m_strFileName));
    */
    WCHAR wszDiagnose[20400];
    short ret = m_PmbWrap.GetImageDiagnose(nImageID, wszDiagnose);

    if (ret != PMB_OK)
    {
        CString str;
        str.Format(L"ERROR - PmBridge Error %d", ret);
        MessageBox(str, NULL, MB_ICONHAND);
        return;
    }
    else {
        MessageBox(wszDiagnose);
    }

    // MessageBox (L"DxGetImageDiagnose was successful");
}


#define EOSW L'\0'
void CDxClientDlg::OnBnClickedButsetdiagnose()
{
    int nImageID = GetImageID();

    if (nImageID < 1)
    {
        MessageBox(L"Cannot set image diagnose ");
        return;
    }

    // const char *szText= "Markku's test diagnose\0";
    UpdateData(true);

    // USES_CONVERSION;
    // const char *szText = W2A(m_strDiagnose);
    // short ret = m_PmbWrap.SetImageDiagnose (nImageID,szText);
    /*
    WCHAR wszDiagnose[20480];
    swprintf(wszDiagnose,20480,L"%s",m_strDiagnose);
    int nLen = wcslen(wszDiagnose);
    wszDiagnose[nLen]=EOSW;
    */
    short ret = m_PmbWrap.SetImageDiagnose(nImageID, m_strDiagnose);

    if (ret != PMB_OK)
    {
        CString str;
        str.Format(L"ERROR - PmBridge Error %d", ret);
        MessageBox(str, NULL, MB_ICONHAND);
        return;
    }

    MessageBox(L"DxSetImageDiagnose was successful");

}



void CDxClientDlg::OnBnClickedButtmin()
{
    m_PmbWrap.SetDxWindowPlacement(SW_SHOWMINIMIZED);
}



void CDxClientDlg::OnBnClickedButtCloseimgs()
{
    m_PmbWrap.CloseAllImages();
}



void CDxClientDlg::OnBnClickedButtGetstudynums()
{
    short nPatientStudies;
    m_PmbWrap.GetNumbOfStudies(&nPatientStudies);
    m_nPatientStudies = nPatientStudies;
    CString str;
    str.Format(L"Number of studies: %d", nPatientStudies);
    MessageBox(str, NULL, MB_ICONHAND);

}


void CDxClientDlg::OnBnClickedButtGetstudies()
{
    short nPatientStudies;
    m_PmbWrap.GetNumbOfStudies(&nPatientStudies);
    if (nPatientStudies < 1) {
        MessageBox(L"No studies found for selected patient", NULL, MB_ICONHAND);
        return;
    }

    m_nPatientStudies = nPatientStudies;

    // reset study ID combo
    int n, nCount = m_comboStudyID.GetCount();
    for (n = 0; n < nCount; n++)
        m_comboStudyID.DeleteString(n);

    m_comboStudyID.ResetContent();

    if (m_pArrStudyID != NULL) {
        delete[] m_pArrStudyID; // crash !!!
        m_pArrStudyID = NULL;
    }

    m_pArrStudyID = new int[m_nPatientStudies];

    short nRet = m_PmbWrap.GetStudies(m_pArrStudyID, m_nPatientStudies);
    if (nRet != PMB_OK) {
        CString str;
        str.Format(L"Failed to get study IDs: %d", nRet);
        MessageBox(str, NULL, MB_ICONHAND);
    }
    else {
        CString str = "";
        CString str2;
        CString strID;
        for (int i = 0; i < m_nPatientStudies; i++) {
            strID.Format(L"%d", m_pArrStudyID[i]);
            str2.Format(L"Study ID:  %s \n", strID);
            str += str2;

            m_comboStudyID.AddString(strID);
        }
        if (m_nPatientStudies > 0) {
            m_comboStudyID.SetCurSel(0);
            MessageBox(str, NULL, MB_ICONHAND);
        }
        else {
            MessageBox(L"No studies found", NULL, MB_ICONHAND);
        }
    }
}


void CDxClientDlg::OnBnClickedButtGetstidNames()
{
    short nPatientStudies;
    m_PmbWrap.GetNumbOfStudies(&nPatientStudies);
    if (nPatientStudies < 1) {
        MessageBox(L"No studies found for selected patient", NULL, MB_ICONHAND);
        return;
    }

    m_nPatientStudies = nPatientStudies;


    // reset study ID combo
    int n, nCount = m_comboStudyID.GetCount();
    for (n = 0; n < nCount; n++)
        m_comboStudyID.DeleteString(n);

    m_comboStudyID.ResetContent();

    if (m_pArrStudyID != NULL) {
        delete[] m_pArrStudyID; // crash !!!
        m_pArrStudyID = NULL;
    }

    if (m_pArrStudyID == NULL) {
        // m_pArrStudyID = new int[m_nPatientStudies];
        m_pArrStudyID = new int[200];
    }

    if (m_pArrStudyIDNames != NULL) {
        // TODO: delete every character array reserved in DLL
        delete[] m_pArrStudyIDNames;
        m_pArrStudyIDNames = NULL;
    }

    if (m_pArrStudyIDNames == NULL) {
        // m_pArrStudyIDNames = new char*[200];
        m_pArrStudyIDNames = new char*[2000];
    }


    short nRet = m_PmbWrap.GetStudiesWithName(m_pArrStudyID, m_pArrStudyIDNames, m_nPatientStudies);
    if (nRet != PMB_OK) {
        CString str;
        str.Format(L"Failed to get study IDs: %d", nRet);
        MessageBox(str, NULL, MB_ICONHAND);
    }
    else {
        CString str = "";
        CString str2;
        CString strID;
        USES_CONVERSION;
        for (int i = 0; i < m_nPatientStudies; i++) {
            strID.Format(L"%d; %s", m_pArrStudyID[i], A2W(m_pArrStudyIDNames[i]));
            str2.Format(L"Study ID & Name:  %s \n", strID);
            str += str2;

            m_comboStudyID.AddString(strID);
        }
        if (m_nPatientStudies > 0) {
            m_comboStudyID.SetCurSel(0);
            MessageBox(str, NULL, MB_ICONHAND);
        }
        else {
            MessageBox(L"No studies found", NULL, MB_ICONHAND);
        }
    }
}

void CDxClientDlg::OnBnClickedButtGetstudyInfo()
{
    CString strStudyIDCombo;
    m_comboStudyID.GetWindowTextW(strStudyIDCombo);

    if (strStudyIDCombo.GetLength() == 0) {
        MessageBox(L"Select study ID from combo box", L"Error", MB_OK);
        return;
    }

    long studyID = _wtol(strStudyIDCombo);

    short nImages;
    short ret = DxGetNumberOfImagesInStudy(studyID, nImages);

    std::wstringstream wss;
    if (ret != PMB_OK) {
        wss << L"DxGetNumberOfImagesInStudy returned error code: " << ret;
        MessageBox(wss.str().c_str(), L"Error", MB_OK);
        return;
    }

    long *imageIDs = (long*)calloc(nImages, sizeof(long*));

    ImageRect *imageRects = (ImageRect*)malloc(nImages * sizeof(ImageRect));

    ret = DxGetStudyInfo(studyID, imageIDs, imageRects);

    if (ret != PMB_OK) {
        wss << L"DxGetStudyInfo returned error code: " << ret;
        MessageBox(wss.str().c_str(), L"Error", MB_OK);
    }
    else {
        for (int i = 0; i < nImages; i++) {
            wss << L"ImageID: " << imageIDs[i]
                << L" x: " << imageRects[i].x << L" y: " << imageRects[i].y
                << L" w: " << imageRects[i].w << L" h: " << imageRects[i].h
                << std::endl;
        }
        MessageBox(wss.str().c_str(), L"OK", MB_OK);
    }

    // Free resources	
    free(imageIDs);
    free(imageRects);
}



void CDxClientDlg::OnBnClickedButStartStudyCapture()
{


    CString strStudyIDCombo;
    m_comboStudyID.GetWindowTextW(strStudyIDCombo);

    /*
    wchar_t studyWCS[100];
    wcscpy(studyWCS,strStudyIDCombo.GetBuffer());
    wchar_t * pwc;
    // Ship first char
    pwc = wcstok(studyWCS, L";");
    */

    int nFound = strStudyIDCombo.Find(L";");
    CString strStudyID = "";
    if (nFound > 1) {
        // strStudyID = strStudyIDCombo.Tokenize();
        strStudyID = strStudyIDCombo.Left(nFound - 1);

    }
    else {
        strStudyID = strStudyIDCombo;
    }

    int nStudyID = _wtoi(strStudyID);
    CString str;
    str.Format(L"(DEBUG) Use study ID:  %d \n", nStudyID);
    MessageBox(str, NULL, MB_ICONHAND);

    UpdateData(true);
    short nRet = m_PmbWrap.StartStudyCapture(nStudyID);
    if (nRet != PMB_OK) {
        str.Format(L"Failed to start study capture. Err = %d", nRet);
        MessageBox(str, NULL, MB_ICONHAND);
    }
    else {
        MessageBox(L"Study found", NULL, MB_ICONHAND);
    }
}




void CDxClientDlg::OnBnClickedButChangeExtId()
{
    const int nMaxCount = 64 + 1; // max length of external id is 64 chars in Romexis DB
    WCHAR curExtID[nMaxCount];

    m_tf_cur_ext_id.GetWindowTextW(curExtID, nMaxCount);

    WCHAR newExtID[nMaxCount];

    m_tf_new_ext_id.GetWindowTextW(newExtID, nMaxCount);

    short nRet = m_PmbWrap.ChangePatientIDW(curExtID, newExtID);
    if (nRet != PMB_OK) {
        CString str;
        str.Format(L"Failed to change ExternalID. Err = %d", nRet);
        MessageBox(str, NULL, MB_ICONHAND);
    }
    else {
        MessageBox(L"ExternalID changed", NULL, MB_ICONHAND);
    }
}


void CDxClientDlg::OnBnClickedButDxstart() {
    OnBnClickedButDxstart(true);
}

void CDxClientDlg::OnBnClickedButDxstart(bool showMsgBoxOnSuccess)
{
    short ret = m_PmbWrap.StartDx();

    if (ret != PMB_OK) {
        std::wstringstream wss;
        wss << L"DxStart returned error code: " << ret;
        MessageBox(wss.str().c_str(), L"Error", MB_OK);
    }
    else if (showMsgBoxOnSuccess) {
        MessageBox(L"Connection to Romexis: OK", L"OK", MB_OK);
    }
}



void CDxClientDlg::OnBnClickedButtGetPatientId()
{
    UpdateData(true);

    CStringW firstName = CT2CW(m_strFirstName);
    CStringW lastName = CT2CW(m_strFamilyName);
    CStringW birthdate = CT2CW(m_strBirthDate);

    std::wstring errorField(L"");

    if (wcslen(firstName) == 0) {
        errorField = L"First name";
    }
    else if (wcslen(lastName) == 0) {
        errorField = L"Family name";
    }
    else if (wcslen(birthdate) == 0) {
        errorField = L"Birth date";
    }

    if (errorField.length() != 0) {
        std::wstring msg(L"Fill required field: ");
        msg += errorField;
        MessageBox(msg.c_str(), L"ERROR", MB_OK | MB_ICONWARNING);
        return;
    }



    int nPatients;
    short ret = DxGetPatientIDWCount(firstName, lastName, birthdate, &nPatients);

    if (ret != PMB_OK) {
      std::wstringstream wss;
      wss << L"Received error code: " << ret;
      MessageBox(wss.str().c_str(), L"ERROR", MB_OK | MB_ICONERROR);
      return;
    }


    int MAX_PATIENT_ID_LENGTH = 64 + 1;
    wchar_t** retPatientIDs = (wchar_t**)malloc(nPatients * sizeof(wchar_t*));
    for (int i = 0; i < nPatients; ++i)
    {
      retPatientIDs[i] = (wchar_t*)malloc(MAX_PATIENT_ID_LENGTH * sizeof(wchar_t));
    }

    ret = DxGetPatientIDW(firstName, lastName, birthdate, nPatients, retPatientIDs);

    if (ret != PMB_OK) {
      std::wstringstream wss;
      wss << L"Received error code: " << ret;
      MessageBox(wss.str().c_str(), L"ERROR", MB_OK | MB_ICONERROR);
      return;
    }

    if (ret != PMB_OK) {
        std::wstringstream wss;
        wss << L"Received error code: " << ret;
        MessageBox(wss.str().c_str(), L"ERROR", MB_OK | MB_ICONERROR);
        return;
    }

    std::wstring msg(L"Patient ID: ");
    msg += retPatientIDs[0];
    MessageBox(msg.c_str(), L"OK", MB_OK);
}



void CDxClientDlg::OnBnClickedButQueryPatient()
{
    UpdateData(true);

    CStringW patientID = CT2CW(m_strPatientID);
    wchar_t firstName[100];
    wchar_t lastName[100];
    wchar_t birthDate[9];

    short ret = DxGetPatientInfoW(patientID, firstName, lastName, birthDate);

    std::wstringstream wss;
    if (ret != PMB_OK) {
        wss << L"DxGetPatientInfoW returned error code: " << ret;
        MessageBox(wss.str().c_str(), L"Error", MB_OK);
        return;
    }

    wss << L"First name: " << firstName << std::endl;
    wss << L"Last name: " << lastName << std::endl;
    wss << L"Birth date: " << birthDate;

    MessageBox(wss.str().c_str(), L"OK", MB_OK);
}
