// DxClientDlg.h : header file
//

#include "afxwin.h"
#if !defined(AFX_DXCLIENTDLG_H__523846C9_6980_11D2_B9F7_00805F25C4B5__INCLUDED_)
#define AFX_DXCLIENTDLG_H__523846C9_6980_11D2_B9F7_00805F25C4B5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CDxClientDlg dialog

#define MAX_IMAGEIDS (int)400

class CDxClientDlg : public CDialog
{
// Construction
public:
	CDxClientDlg(CWnd* pParent = NULL);	// standard constructor

	~CDxClientDlg();

// Dialog Data
	//{{AFX_DATA(CDxClientDlg)
    bool m_bToggleAlwaysOnTop = false;
	enum { IDD = IDD_DXCLIENT_DIALOG };
	CComboBox	m_comboImageIndex;
	CButton	m_buttonXRay;
	CString	m_strPatientID;
	CString	m_strBirthDate;
	CString	m_strDoctor;
	CString	m_strFamilyName;
	CString	m_strFirstName;
	CString	m_strFileName;
	int		m_rbFormat;
	BOOL	m_bConvertTo8Bit;
	BOOL	m_bEnhance;
	BOOL	m_bOverview;
	CString	m_strLoginUser;
	CString m_strGender;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDxClientDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CDxClientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnBtnSelectPatient();
	afx_msg void OnBtnInsertPatient();
	afx_msg void OnBtnDeletePatient();
	afx_msg void OnBtnUpdatePatient();
	afx_msg void OnBtnInquireImages();
	afx_msg void OnBtnGetImage();
	afx_msg void OnBtnSelectImage();
	afx_msg void OnBtnDeselectPatient();
	afx_msg void OnBtnSetUser();
	afx_msg void OnBtnRwndFull();
	afx_msg void OnBtnRwndSmall();
	afx_msg void OnBtnWorklist();
	afx_msg void OnBtnRwndClose();
	afx_msg void OnBtnCaptCam();
	afx_msg void OnBtnCaptCeph();
	afx_msg void OnBtnCaptIntra();
	afx_msg void OnBtnCaptPan();
    afx_msg void OnBtnNormalizeWindow();
	afx_msg void OnBtnMaximizeWindow();
	afx_msg void OnBtnCaptCRScanner();
	afx_msg void OnBtnCaptTwain();
	afx_msg void OnButopenimage();
	afx_msg void OnBut3d();
	afx_msg void OnButexit();
	afx_msg void OnButgetimagebyid();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	CPmbWrap m_PmbWrap ;

	short m_nImageCount ;
	short m_nPatientStudies;
	int *m_pArrStudyID;
	char **m_pArrStudyIDNames;

	int m_nImageID[MAX_IMAGEIDS] = {0}; // MKH 2010/08/03 Image index vs. ID table 
	int m_nImageType[MAX_IMAGEIDS]; // MKH 2014/08/01  
	char m_szGender[_MAX_PATH];
	short m_nCaseCount;
	void GetCadCamIDNums(const char *pFileNam);  //From XML file 2016/06
	int GetImageID();


public:
	CComboBox m_cbGender;
	afx_msg void OnSelchangeComboGender();
	afx_msg void OnBnClickedButcadcam();
	BOOL m_bAllCadCamCases;
	CComboBox m_comboCaseID;
	afx_msg void OnBnClickedButLaunchcase();
	afx_msg void OnBnClickedButclinic();
	afx_msg void OnBnClickedButgetcstatus();
	afx_msg void OnBnClickedButgetdiagnose();
	afx_msg void OnBnClickedButsetdiagnose();
	CComboBox m_comboModule;


	CEdit m_editDianose;
	CString m_strDiagnose;
	afx_msg void OnBnClickedButtmin();
	afx_msg void OnBnClickedButtCloseimgs();
	afx_msg void OnBnClickedButtGetstudynums();
	afx_msg void OnBnClickedButtGetstudies();
	afx_msg void OnBnClickedButtGetstudyInfo();
	CComboBox m_comboStudyID;
	afx_msg void OnBnClickedButStartStudyCapture();
	afx_msg void OnBnClickedButtGetstidNames();
	afx_msg void OnBnClickedButChangeExtId();
	CEdit m_tf_cur_ext_id;
	CEdit m_tf_new_ext_id;
	afx_msg void OnBnClickedButDxstart();
	void OnBnClickedButDxstart(bool showMsgBoxOnSuccess);
	afx_msg void OnBnClickedButQueryPatient();
	afx_msg void OnBnClickedButtGetPatientId();
    afx_msg void OnBnClickedButtAlwaysOnTop();
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DXCLIENTDLG_H__523846C9_6980_11D2_B9F7_00805F25C4B5__INCLUDED_)
