
// PmbWrap.h

// Wrapper class for Planmec's PmBridge


#include "PmBridge.h"

#ifdef _WIN64
#define PMB_DLL L"PmBridge_64.dll"
#else
#define PMB_DLL L"PmBridge.dll"
#endif



#define DX_START                "DxStart"
#define DX_SETWINDOWPLACEMENT   "DxSetWindowPlacement"
#define DX_SELECT_PATIENT       "DxSelectPatient"

#define DX_INSERT_PATIENTW       "DxInsertPatientW"
#define DX_UPDATE_PATIENTW       "DxUpdatePatientW"
#define DX_INSERT_PATIENTW_EX    "DxInsertPatientW_Ex" // MKH 2013/11/13
#define DX_UPDATE_PATIENTW_EX    "DxUpdatePatientW_Ex" // MKH 2013/11/13

#define DX_CHANGE_PATIENT_IDW    "DxChangePatientIDW"

#define DX_DELETE_PATIENT       "DxDeletePatient"
#define DX_GET_DBSTATUS         "DxGetDBStatus"

#define DX_SET_USER				"DxSetUser"
#define DX_SELECT_IMAGE         "DxSelectImage"
#define DX_CAPTURE_IMAGE        "DxCaptureImage"
#define DX_CAPTURE_IMAGE_INTRA  "DxCaptureImageIntra"  // MKH 2010/08/11

#define DX_INQUIRE_IMAGE        "DxInquireImage"
#define DX_INQUIRE_CADCAM_CASE	"DxInquireCadCamCase"  // MKH 2016/05

#define DX_GET_IMAGE            "DxGetImage"
#define DX_GET_IMAGE_BYID        "DxGetImageByID"   // MKH 2010/08/05

#define DX_OPEN_IMAGE            "DxOpenImage"
#define DX_GET_OVERVIEW_IMAGE    "DxGetOverviewImage"
#define DX_GET_OVERVIEW_IMAGE_BYID "DxGetOverviewImageByID"  // MKH 2010/08/05
#define DX_OPEN_CADCAM_CASE            "DxOpenCadCamCase"   // 2016/06/23

// MKH 2016/09
#define DX_SELECT_MODULE          "DxSelectRmxModule"  
#define DX_GET_CLINIC_STATUS     "DxGetClinicStatus"  
#define DX_GET_CLINIC_STATUS_STRING     "DxGetClinicStatusString"  
#define DX_GET_IMAGE_DIAGNOSE     "DxGetImageDiagnose"  
#define DX_SET_IMAGE_DIAGNOSE     "DxSetImageDiagnose"  

#define DX_DESELECT_PATIENT     "DxDeselectPatient"

#define DX_MOVE_WINDOW			"DxMoveWindow"
#define DX_SET_RETRIEVAL_SIZE   "DxSetImageRetrievalWindowSize"
#define DX_GET_RETRIEVAL_SIZE   "DxGetImageRetrievalWindowSize"

#define DX_SET_MAX_LIMITS       "DxSetMaxLimits"

#define DX_SET_WORKLIST_ENTRY   "DxSetWorklistEntry"

#define DX_EXIT                 "DxExit"

#define DX_CLOSE_ALLIMAGES          "DxCloseAllImages"
#define DX_GET_NUMBEROFSTUDIES          "DxGetNumberOfStudies" // 2018/11/01
#define DX_GET_STUDIES				 "DxGetStudies" // 2018/11/01
#define DX_GET_STUDIES_NAME          "DxGetStudies_Name" // 2018/11/01
#define DX_GET_STUDY_INFO          "DxGetStudyInfo" // 2018/11/02
#define DX_START_STUDY_CAPTURE          "DxCaptureStudy" // 2018/11/07

#define CALLINGCONVENTION WINAPI

typedef DWORD (CALLINGCONVENTION *pDxStart) ();

typedef short (CALLINGCONVENTION *pDxSetWindowPlacement) (
	UINT uShowCmd
	);

typedef short (CALLINGCONVENTION *pDxSelectPatient) (
	const char *pszPatientID,
	short *pnImageCount
	);

typedef short (CALLINGCONVENTION *pDxCloseAllImages) (
	);

typedef short (CALLINGCONVENTION *pDxGetNumsOfStudies) (
	short *pnStudiesCount
	);

typedef short (CALLINGCONVENTION *pDxGetStudies) (
	int arrStudies[], int nArrLen
	);

typedef short (CALLINGCONVENTION *pDxGetStudies_Name) (
	int arrStudies[], char **arrNames, int nArrLen
	);

typedef short (CALLINGCONVENTION *pDxGetStudyInfo) (
	int nStudyID, const char* fileName
	);

typedef short (CALLINGCONVENTION *pDxStartStudyCapture) (
	int nStudyID
	);

typedef short (CALLINGCONVENTION *pDxInsertPatientW) (
	const char  *pszPatientID,
	const WCHAR *pwszFamilyName,
	const WCHAR *pwszFirstName,
	const char  *pszBirthDate,
	const WCHAR *pwszDoctor
	);

typedef short (CALLINGCONVENTION *pDxInsertPatientW_Ex) (
	const char  *pszPatientID,
	const WCHAR *pwszFamilyName,
	const WCHAR *pwszFirstName,
	const char  *pszBirthDate,
	const WCHAR *pwszDoctor,
	const char *pszGender
	);

typedef short (CALLINGCONVENTION *pDxUpdatePatientW) (
	const char  *pszPatientID,
	const WCHAR *pwszFamilyName,
	const WCHAR *pwszFirstName,
	const char  *pszBirthDate,
	const WCHAR *pszDoctor
	);

typedef short (CALLINGCONVENTION *pDxUpdatePatientW_Ex) (
	const char  *pszPatientID,
	const WCHAR *pwszFamilyName,
	const WCHAR *pwszFirstName,
	const char  *pszBirthDate,
	const WCHAR *pszDoctor,
	const char *pszGender
	);

typedef short (CALLINGCONVENTION *pDxChangePatientIDW) (
	const wchar_t *oldExternalID, const wchar_t *newExternalID
	);

typedef short (CALLINGCONVENTION *pDxDeletePatient) (
	const char *pszPatientID
	);

typedef short (CALLINGCONVENTION *pDxGetDBStatus) (
	);

typedef short (CALLINGCONVENTION *pDxExit) (
	);

typedef short (CALLINGCONVENTION *pDxInquireImage) (
	short nIndex,
	long  arrImageParam [],
	short arrToothMask  []
	);

typedef short (CALLINGCONVENTION *pDxGetImage) (
	short nIndex,
	short nConvertTo8bit,
	short nEnhance,
	short nFileFormat,
	const char *pszFileName
	);

typedef short (CALLINGCONVENTION *pDxInquireCadCamCase) (
	const int nID,
	const char *pszFileName
	);


// MKH 2010/08/05
typedef short (CALLINGCONVENTION *pDxGetImageByID) (
	int nImageID,
	short nConvertTo8bit,
	short nEnhance,
	short nFileFormat,
	const char *pszFileName
	);


// MKH 2010/06/04
typedef short (CALLINGCONVENTION *pDxOpenImage) (
	short nIndex,
	int nImageID
	);

// 2016/06/23
typedef short (CALLINGCONVENTION *pDxOpenCadCamCase) (
	int nCaseID
	);


typedef short (CALLINGCONVENTION *pDxGetOverviewImage) (
	short nIndex,
	short nFileFormat,
	const char *pszFileName
	);

// MKH 2010/08/05
typedef short (CALLINGCONVENTION *pDxGetOverviewImageByID) (
	int nImageID,
	short nFileFormat,
	const char *pszFileName
//	short nEnhance  // Thumbnail always processed in Romexis
	);

typedef short (CALLINGCONVENTION *pDxSelectImage) ();

typedef short (CALLINGCONVENTION *pDxCaptureImage) (
	short nImageType
	);

// MKH 2016/09
typedef short (CALLINGCONVENTION *pDxSelectRmxModule) (int nModule); 
typedef short (CALLINGCONVENTION *pDxGetClinicStatus) (const char * szFileName); 
typedef short (CALLINGCONVENTION *pDxGetClinicStatusStr) (WCHAR * wszXMLStatus); 


// typedef short (CALLINGCONVENTION *pDxGetImageDiagnose) (int nImageID, const char * szFileName); 
typedef short (CALLINGCONVENTION *pDxGetImageDiagnose) (int nImageID, WCHAR * wszDiagnose); 
typedef short (CALLINGCONVENTION *pDxSetImageDiagnose) (int nImageID, const WCHAR * wszText); 

typedef short (CALLINGCONVENTION *pDxCaptureImageIntra) ( // MKH 2010/08/11
	short nUseStudy, short nAllowWithoutStudy
	);

typedef short (CALLINGCONVENTION *pDxMoveWindow) (
	long x0,
	long y0,
	long nWidth,
	long nHeight
	);

typedef short (CALLINGCONVENTION *pDxSetUser) (
	const char *pszUserName,
	unsigned short nAccessLevel
	);

typedef short (CALLINGCONVENTION *pDxDeselectPatient) ();

typedef short (CALLINGCONVENTION *pDxSetImageRetrievalWindowSize) (
	short nSize
	);

typedef short (CALLINGCONVENTION *pDxGetImageRetrievalWindowSize) (
	short *pnWindowSize,
	long  *pnLeft,
	long  *pnRight,
	long  *pnTop,
	long  *pnBottom
	);

typedef short (CALLINGCONVENTION *pDxSetMaxLimits) (
	long nMinTop,
	long nMaxBottom,
	long nMinLeft,
	long nMaxRight
	);


typedef short (CALLINGCONVENTION *pDxSetWorklistEntry) (
	const char *pszPatientID,
	const char *pszStartDate,
	const char *pszStartTime,
	const char *pszModality,
	const char *pszStepID,
	const char *pszStepDesc,
	const char *pszProcedureID,
	const char *pszProcedureDesc,
	const char *pszStudyInstanceUID,
	const char *pszAccessionNumber,
	short arrToothMask  []
	);





class CPmbWrap
{
public:
	CPmbWrap ();
	~CPmbWrap ();

	short StartDx ();

	short SetDxWindowPlacement (
		UINT uShowCmd
		);

	boolean LoadPMLibrary(); // MKH 2018/06/04 MKH Entteri test
	boolean FreePMLibrary(); // MKH 2018/06/04 MKH Entteri test

	short SelectPatient (
		const char *pszPatientID,  // In
		short *pnImageCount        // Out
		);


	short InsertPatientW (
		const char  *pszPatientID,
		const WCHAR *pwszFamilyName,
		const WCHAR *pwszFirstName,
		const char  *pszBirthDate,
		const WCHAR *pwszDoctor
		);

	short InsertPatientW_Ex (
		const char  *pszPatientID,
		const WCHAR *pwszFamilyName,
		const WCHAR *pwszFirstName,
		const char  *pszBirthDate,
		const WCHAR *pwszDoctor,
		const char *pszGender
		);

	short UpdatePatientW (
		const char  *pszPatientID,
		const WCHAR *pwszFamilyName,
		const WCHAR *pwszFirstName,
		const char  *pszBirthDate,
		const WCHAR *pszDoctor
		);

	short UpdatePatientW_Ex (
		const char  *pszPatientID,
		const WCHAR *pwszFamilyName,
		const WCHAR *pwszFirstName,
		const char  *pszBirthDate,
		const WCHAR *pszDoctor,
		const char *pszGender
		);

	// MKH 2016/09
	short SelectRmxModule(int nModule);
	short GetClinicStatus(const char * szFileName);
	short GetClinicStatusStr(WCHAR * pwszDiagnose); 

	short GetImageDiagnose(int nImageNumber, WCHAR * wszDiagnose);
	short SetImageDiagnose(int nImageNumber, const WCHAR * wszDiagnose);


	short ChangePatientIDW(const wchar_t *oldExcternalID, const wchar_t *newExternalID);

	short DeletePatient (
		const char *pszPatientID
		);


	short GetDBStatus (
		);

	short ExitDx (
		);

	short InquireImage (
		short nIndex,
		long  arrImageParam [],
		short arrToothMask  []
		);

	short GetImage (
		short nIndex,
		short nConvertTo8bit,
		short nEnhance,
		short nFileFormat,
		const char *pszFileName
		);

	short InquireCadCamCase (
		int nID,
		const char *pszFileName
	);

	// MKH 2010/08/05
	short GetImageByID (
		int nImageID,
		short nConvertTo8bit,
		short nEnhance,
		short nFileFormat,
		const char *pszFileName
	);

	// MKH 2010/06/04
	short OpenImage (
		short nIndex,
		int nID
	);


	// MKH 2018/10/17
	short CloseAllImages();
	short GetNumbOfStudies(short *nNums);
	short GetStudies(int *arrStudy, int nNums);
	short GetStudiesWithName(int *arrStudy, char **arrNames,int nNums);
	short GetStudyInfo(int nStudyID, const char * xmlFileName);
	short StartStudyCapture(int nStudyID);

	// MKH 2016/06/23
	short OpenCadCamCase (
		int nCaseID
	);

	short GetOverviewImage (
		short nIndex,
		short nFileFormat,
		const char *pszFileName
		);

	// MKH 2010/08/05
	short GetOverviewImageByID (
		int nImageID,
		short nFileFormat,
		const char *pszFileName
//		short nEnhance // MKH 2010/08/11 thumbnail always processed in Romexis
		);


	short SelectImage ();

	short CaptureImage (
		short nImageType
		);

	short CaptureImageIntra (
	   short nUseStudy, short nAllowWithoutStudy
        ); // MKH 2010/08/11

	short SetUser (
		const char *pszUserName,
		unsigned short nAccessLevel
		);

	short DeselectPatient ();

	short SetImageRetrievalWindowSize ( short nSize );

	short GetImageRetrievalWindowSize (
		short *pnWindowSize,
		long  *pnLeft,
		long  *pnRight,
		long  *pnTop,
		long  *pnBottom
		);

	short ShowToolbar (short nShow);
	short ShowStatusbar (short nShow);

	short SetMaxLimits (
		long nMinTop,
		long nMaxBottom,
		long nMinLeft,
		long nMaxRight
		);

	short SetWorklistEntry (
		const char *pszPatientID,
		const char *pszStartDate,
		const char *pszStartTime,
		const char *pszModality,
		const char *pszStepID,
		const char *pszStepDesc,
		const char *pszProcedureID,
		const char *pszProcedureDesc,
		const char *pszStudyInstanceUID,
		const char *pszAccessionNumber,
		short arrToothMask  []
		);

		HMODULE m_hPmbDLL; // Entteri test 2018/06/04

private:
	void GetDimaxisPath ( CString & strPath );

	// HMODULE m_hPmbDLL;

	pDxStart m_pDxStart ;
	pDxGetDBStatus m_pDxGetDBStatus ;
	pDxExit m_pDxExit ;

	pDxSetWindowPlacement m_pDxSetWindowPlacement ;

	pDxSelectPatient m_pDxSelectPatient ;

	pDxInsertPatientW m_pDxInsertPatientW ;
	pDxInsertPatientW_Ex m_pDxInsertPatientW_Ex ;

	pDxUpdatePatientW m_pDxUpdatePatientW ;
	pDxUpdatePatientW_Ex m_pDxUpdatePatientW_Ex ;

	pDxChangePatientIDW m_pDxChangePatientIDW;

	pDxDeletePatient m_pDxDeletePatient ;

	pDxSelectImage m_pDxSelectImage ;
	pDxCaptureImage m_pDxCaptureImage ;
	pDxCaptureImageIntra m_pDxCaptureImageIntra ; // MKH 2010/08/11


	pDxInquireImage m_pDxInquireImage ;
	pDxGetImage m_pDxGetImage;
	pDxInquireCadCamCase m_pDxInquireCadCamCase;  // MKH 2016/05
	pDxGetImageByID m_pDxGetImageByID ;   // MKH 2010/08/04

	pDxOpenImage m_pDxOpenImage ;  // MKH 2010/06/04
	pDxCloseAllImages m_pDxCloseAllImages;  // MKH 2018/10/17
	pDxGetNumsOfStudies m_pDxGetNumsOfStudies;  // MKH 2018/11/01
	pDxGetStudies m_pDxGetStudies;  // MKH 2018/11/01
	pDxGetStudies_Name m_pDxGetStudies_Name; // MKH 2018/11/01
	pDxGetStudyInfo m_pDxGetStudyInfo;  // MKH 2018/11/02
	pDxStartStudyCapture m_pDxStartStudyCapture;  // MKH 2018/11/07

	pDxOpenCadCamCase m_pDxOpenCadCamCase;  // 2016/06/23

	pDxGetOverviewImage m_pDxGetOverviewImage ;
	pDxGetOverviewImageByID m_pDxGetOverviewImageByID ;// MKH 2010/08/04

	pDxSetUser m_pDxSetUser ;
	pDxDeselectPatient m_pDxDeselectPatient ;

	pDxSetImageRetrievalWindowSize m_pDxSetImageRetrievalWindowSize ;
	pDxGetImageRetrievalWindowSize m_pDxGetImageRetrievalWindowSize ;

	pDxMoveWindow m_pDxMoveWindow ;
	pDxSetMaxLimits m_pDxSetMaxLimits ;

	pDxSetWorklistEntry m_pDxSetWorklistEntry ;

	// MKH 2016/09
	pDxSelectRmxModule m_pDxSelectRmxModule; 

	pDxGetClinicStatus m_pDxGetClinicStatus; 
	pDxGetClinicStatusStr m_pDxGetClinicStatusStr; 

	pDxGetImageDiagnose m_pDxGetImageDiagnose; 
	pDxSetImageDiagnose m_pDxSetImageDiagnose; 

};
